improved amd64 on i386 build attempt bailout msg
[grml-debootstrap.git] / grml-debootstrap
index a3db195..ac1fe8b 100755 (executable)
@@ -58,7 +58,7 @@ MNTPOINT="/mnt/debootstrap.$$"
 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
-[ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://http.debian.net/debian'
+[ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://httpredir.debian.org/debian'
 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
 [ -n "$FORCE" ] || FORCE=''
 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
@@ -69,11 +69,12 @@ MNTPOINT="/mnt/debootstrap.$$"
 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
 [ -n "$PACKAGES" ] || PACKAGES='yes'
+[ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
 [ -n "$RELEASE" ] || RELEASE='jessie'
 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
-[ -n "$SCRIPTS" ] || SCRIPTS='yes'
+[ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
 [ -n "$SECURE" ] || SECURE='yes'
 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
@@ -83,6 +84,7 @@ MNTPOINT="/mnt/debootstrap.$$"
 # inside the chroot system locales might not be available, so use minimum:
 export LANG=C
 export LC_ALL=C
+export LANGUAGE=C
 
 # make sure interactive mode is only executed when
 # using an empty configuration file or option --interactive
@@ -116,10 +118,12 @@ Bootstrap options:
 
 Options for Virtual Machine deployment:
 
-      --vm               Set up a Virtual Machine, instead of plainly installing
-                         to a partition or directory, to be combined with --target,
-                         like: --vm --target /dev/mapper/your-vm-disk
-      --vmfile           Like --vm, but install into a file (raw format).
+      --vm               Set up a Virtual Machine on an existing block device
+                         instead of plainly installing to a partition or
+                         directory. Needs to be combined with --target.
+                         Example: --vm --target /dev/mapper/your-vm-disk
+      --vmfile           Like --vm, but install into a regular file (created by
+                         'qemu-img create -f raw ...') instead.
                          Example: --vmfile --target /mnt/sda1/qemu.img
       --vmsize <size>    Use specified size for size of VM file (default: 2G).
                          Syntax as supported by qemu-img, like: --vmsize 3G
@@ -153,6 +157,7 @@ Configuration options:
       --chroot-scripts <d> Execute chroot scripts from specified directory.
       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
+      --remove-configs     Delete grml-debootstrap configuration files from installed system.
 
 Other options:
 
@@ -376,7 +381,7 @@ fi
 [ "$_opt_packages_set" ]        && PACKAGES='yes'
 [ "$_opt_nopackages" ]          && PACKAGES=''
 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
-[ "$_opt_scripts_set" ]         && SCRIPTS='yes'
+[ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
@@ -395,12 +400,27 @@ fi
 [ "$_opt_force" ]               && FORCE=$_opt_force
 [ "$_opt_verbose" ]             && VERBOSE="-v"
 [ "$_opt_debug" ]               && DEBUG="true"
+[ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
 
 # make sure main is always included
 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
 [ "$_opt_non_free" ]            && COMPONENTS="$COMPONENTS non-free"
 
+# command line option checks
+if [ "$_opt_scripts_set" ] ; then
+  ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
+  SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
+fi
+
+if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
+  eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
+  eerror "The --grub option is unneeded as GRUB will be installed automatically."
+  eend 1
+  bailout 1
+fi
+
+
 if [ "$DEBUG" = "true" ] ; then
   set -x
 fi
@@ -632,7 +652,7 @@ prompt_for_mirror()
   [ $? -eq 0 ] || bailout
 
   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
-     [ -n "$MIRROR" ] || MIRROR='http://http.debian.net/debian'
+     [ -n "$MIRROR" ] || MIRROR='http://httpredir.debian.org/debian'
      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
                "Please enter Debian mirror you would like to use for installing packages." \
                0 0 $MIRROR)"
@@ -765,6 +785,8 @@ elif [ -n "$INTERACTIVE" ] ; then
    Using ISO:       $ISO"
    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
    Using arch:      $ARCH"
+   [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
+   Config files:    $CONFFILES"
 
    INFOTEXT="$INFOTEXT
 
@@ -788,11 +810,12 @@ else # if not running automatic installation display configuration and prompt fo
      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
    fi
 
-   [ -n "$RELEASE" ]  && echo "   Using release:   $RELEASE"
-   [ -n "$HOSTNAME" ] && echo "   Using hostname:  $HOSTNAME"
-   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
-   [ -n "$ISO" ]      && echo "   Using ISO:       $ISO"
-   [ -n "$ARCH" ]     && echo "   Using arch:      $ARCH"
+   [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
+   [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
+   [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
+   [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
+   [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
+   [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
    if [ -n "$VIRTUAL" ] ; then
       echo "   Deploying as Virtual Machine."
       if [ -n "$VMSIZE" -a -n "$VMFILE" ]; then
@@ -869,7 +892,7 @@ fi
 CURRENT_ARCH="$(uname -m)"
 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
    if [ "$ARCH" = "amd64" ] ; then
-      eerror "It is not possible to build amd64 on $CURRENT_ARCH." ; eend 1
+      eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead." ; eend 1
       bailout 1
    fi
 fi
@@ -1121,8 +1144,6 @@ prepare_vm() {
   LOOP_PART="$(echo "${DEVINFO##add map }" | sed 's/ .*//')" # 'loop1p1'
   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
 
-  blockdev --rereadpt "${LOOP}"
-
   if [ -z "$TARGET" ] ; then
      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
      bailout 1
@@ -1150,6 +1171,12 @@ finalize_vm() {
 # chroot-script skips installation for unset ${GRUB}
 if [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | fgrep -q GRUB; then
   einfo "Installing Grub as bootloader."
+
+  if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
+    echo "Notice: grub-pc package not present yet, installing it therefore."
+    DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y install $DPKG_OPTIONS grub-pc
+  fi
+
   mkdir -p "${MNTPOINT}/boot/grub"
   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
@@ -1176,9 +1203,22 @@ fi
   chroot "${MNTPOINT}" update-grub
 
   case "$RELEASE" in
+    jessie)
+      einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
+      mkdir -p "${MNTPOINT}/boot/grub/fonts/"
+      cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
+      ;;
+  esac
+
+  case "$RELEASE" in
     lenny|squeeze|wheezy)
-      einfo "Adjusting grub.cfg for successful boot sequence."
-      sed -i "s;root=[^ ]\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
+      if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
+        ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
+        ewarn "Please note that your system might NOT be able to properly boot."
+      else
+        einfo "Adjusting grub.cfg for successful boot sequence."
+        sed -i "s;root=[^ ]\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
+      fi
       ;;
   esac
 
@@ -1268,6 +1308,7 @@ preparechroot() {
   [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                                                      >> "$CHROOT_VARIABLES"
   [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                                                        >> "$CHROOT_VARIABLES"
   [ -n "$PACKAGES" ]            && echo "PACKAGES='$(sed "s,','\\\\'',g" <<<"${PACKAGES}")'"                       >> "$CHROOT_VARIABLES"
+  [ -n "$POST_SCRIPTS" ]        && echo "POST_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${POST_SCRIPTS}")'"               >> "$CHROOT_VARIABLES"
   [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${PRE_SCRIPTS}")'"                 >> "$CHROOT_VARIABLES"
   [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE='$(sed "s,','\\\\'',g" <<<"${RECONFIGURE}")'"                 >> "$CHROOT_VARIABLES"
   [ -n "$RELEASE" ]             && echo "RELEASE='$(sed "s,','\\\\'',g" <<<"${RELEASE}")'"                         >> "$CHROOT_VARIABLES"
@@ -1300,8 +1341,10 @@ preparechroot() {
   fi
 
   # package selection:
-  cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
-    "${MNTPOINT}"/etc/debootstrap/packages
+  if [ "$PACKAGES" = 'yes' ] ; then
+    cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
+      "${MNTPOINT}"/etc/debootstrap/packages
+  fi
 
   # debconf preseeding:
   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
@@ -1388,33 +1431,45 @@ iface eth0 inet dhcp
 
 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
 execute_pre_scripts() {
-   # make sure we have $MNTPOINT available for our scripts
-   export MNTPOINT
-   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
-      [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="$CONFFILES/pre-scripts/"
-      for script in ${pre_scripts}/* ; do
-         if [ -x "$script" ] ; then
-            einfo "Executing pre-script $script"
-            $script ; eend $?
-         fi
-      done
-   fi
+  # make sure hostname is set even before chroot-script get executed
+  echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
+
+  # make sure we have $MNTPOINT available for our scripts
+  export MNTPOINT
+
+  if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
+    [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
+    for script in "${pre_scripts}"/* ; do
+      if [ -x "$script" ] ; then
+        einfo "Executing pre-script $script"
+        "$script" ; eend $?
+      fi
+    done
+  fi
 }
 # }}}
 
-# execute all scripts in /etc/debootstrap/scripts/ {{{
-execute_scripts() {
-   # make sure we have $MNTPOINT available for our scripts
-   export MNTPOINT
-   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
-      [ -d "$_opt_scripts" ] && scripts="$_opt_scripts" || scripts="$CONFFILES/scripts/"
-      for script in ${scripts}/* ; do
-         if [ -x "$script" ] ; then
-            einfo "Executing script $script"
-            $script ; eend $?
-         fi
-      done
-   fi
+# execute all scripts in /etc/debootstrap/post-scripts/ {{{
+execute_post_scripts() {
+  # make sure we have $MNTPOINT available for our scripts
+  export MNTPOINT
+
+  if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
+    # legacy support for /etc/debootstrap/scripts/
+    [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
+    ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
+  elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
+    [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
+  fi
+
+  if [ -n "$post_scripts" ] ; then
+    for script in "${post_scripts}"/* ; do
+      if [ -x "$script" ] ; then
+        einfo "Executing post-script $script"
+        "$script" ; eend $?
+      fi
+    done
+  fi
 }
 # }}}
 
@@ -1516,10 +1571,27 @@ fscktool() {
 }
 # }}}
 
+# get rid of grml-debootstrap config files {{{
+remove_configs() {
+  if [ "$REMOVE_CONFIGS" != "yes" ] ; then
+    return 0
+  fi
+
+  if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
+    ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files." ; eend 0
+    return 0
+  fi
+
+  einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
+  rm -rf "${MNTPOINT}"/etc/debootstrap/
+  eend $?
+}
+# }}}
+
 # now execute all the functions {{{
 for i in prepare_vm mkfs tunefs mount_target debootstrap_system \
-         preparechroot execute_pre_scripts chrootscript execute_scripts \
-         umount_chroot finalize_vm fscktool ; do
+         preparechroot execute_pre_scripts chrootscript execute_post_scripts \
+         remove_configs umount_chroot finalize_vm fscktool ; do
     if stage "${i}" ; then
       if "$i" ; then
         stage "${i}" 'done' && rm -f "${STAGES}/${i}"